/*
 * Tic Tac Toe 
 * DUMITRESCU Evelina 341C3
 *
 */


#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>


typedef struct _led {
	uint8_t port[2];
	volatile uint8_t *regs[2];
	uint8_t state;
} led;


led map[3][3];
int finished = 0;
#define EMPTY	0
#define RED		2
#define GREEN	1
#define DRAW 3

#define UP		0
#define DOWN	1
#define LEFT	2
#define RIGHT	3

#define PIN_BUTTON_UP PB3
#define PIN_BUTTON_DOWN PB2
#define PIN_BUTTON_LEFT PB4
#define PIN_BUTTON_RIGHT PB0
#define PIN_BUTTON_SELECT PB1
#define LOCK_INPUT_TIME 1000

int x=0, y=0;
int player = GREEN-1;

/* setare pini leduri*/
void initialize_leds()
{

	DDRD |= ((1 << PD0) | (1 << PD1)  | (1 << PD4) | (1 << PD5) | (1<<PD6));
	DDRA |= ((1 << PA0) | (1 << PA1) | (1 << PA2) | (1 << PA3) | (1 << PA4) | (1 << PA5) | (1 << PA6) | (1 << PA7));
	DDRC |= ((1 << PC7) | (1 << PC6) | (1 << PC5) | (1 << PC4) | (1<<PC1));
	
	PORTC |= (1 << PC7); 
	PORTC |= (1 << PC6);
	PORTC |= (1 << PC5); 
	PORTC |= (1 << PC4);
	PORTC |= (1 << PC1);
	
	PORTA |= (1 << PA0);
	PORTA |= (1 << PA1);
	PORTA |= (1 << PA2); 
	PORTA |= (1 << PA3); 
	PORTA |= (1 << PA4); 
	PORTA |= (1 << PA5); 
	PORTA |= (1 << PA6); 
	PORTA |= (1 << PA7); 
	
	PORTD |= (1 << PD0);
	PORTD |= (1 << PD1);
	PORTD |= (1 << PD4); 
	PORTD |= (1 << PD5); 
	PORTD |= (1 << PD6); 	
	
}

/*setare pini butoane*/
void initialize_buttons()
{

	/* setez pinul PB0 ca intrare */
	DDRB &= ~(1 << PB0);
	/* activez rezistenta de pull-up pentru pinul PB0*/
	PORTB |= (1 << PB0);

	/* setez pinul PB1 ca intrare */
	DDRB &= ~(1 << PB1);
	/* activez rezistenta de pull-up pentru pinul PB1*/
	PORTB |= (1 << PB1);

	/* setez pinul PB2 ca intrare */
	DDRB &= ~(1 << PB2);
	/* activez rezistenta de pull-up pentru pinul PB2*/
	PORTB |= (1 << PB2);

	/* setez pinul PB3 ca intrare */
	DDRB &= ~(1 << PB3);
	/* activez rezistenta de pull-up pentru pinul PB3*/
	PORTB |= (1 << PB3);

	/* setez pinul PB4 ca intrare */	
	DDRB &= ~(1 << PB4);
	/* activez rezistenta de pull-up pentru pinul PB4*/
	PORTB |= (1 << PB4);

	
}

/*initializare pini matrice leduri verzi*/
void initialize_map_green_leds()
{
	map[0][0].port[GREEN-1] = PD0;
	map[0][1].port[GREEN-1] = PC6;
	map[0][2].port[GREEN-1] = PA0;
	
	
	map[0][0].regs[GREEN-1] = &PORTD;
	map[0][1].regs[GREEN-1] = &PORTC;
	map[0][2].regs[GREEN-1] = &PORTA;
	
	
	map[1][0].port[GREEN-1] = PC3;//PD2;
	map[1][1].port[GREEN-1] = PC4;
	map[1][2].port[GREEN-1] = PA2;
	
	map[1][0].regs[GREEN-1] = &PORTC;//PD2;
	map[1][1].regs[GREEN-1] = &PORTC;
	map[1][2].regs[GREEN-1] = &PORTA;
	
	
	map[2][0].port[GREEN-1] = PD4;
	map[2][1].port[GREEN-1] = PA7;
	map[2][2].port[GREEN-1] = PA4;
	
	
	map[2][0].regs[GREEN-1] = &PORTD;
	map[2][1].regs[GREEN-1] = &PORTA;
	map[2][2].regs[GREEN-1] = &PORTA;
	
	
	
	
}

/*initializare pini matrice leduri rosii*/
void initialize_map_red_leds()
{
	map[0][0].port[RED-1] = PD1;
	map[0][1].port[RED-1] = PC5;
	map[0][2].port[RED-1] = PA1;		

	map[0][0].regs[RED-1] = &PORTD;
	map[0][1].regs[RED-1] = &PORTC;
	map[0][2].regs[RED-1] = &PORTA;		

	
	map[1][0].port[RED-1] = PD6;//PD3;
	map[1][1].port[RED-1] = PC7;
	map[1][2].port[RED-1] = PD3;	
	
	
	
	map[1][0].regs[RED-1] = &PORTD;//PD3;
	map[1][1].regs[RED-1] = &PORTC;
	map[1][2].regs[RED-1] = &PORTD;	
	
		
	map[2][0].port[RED-1] = PD5;
	map[2][1].port[RED-1] = PA6;
	map[2][2].port[RED-1] = PA5;


	map[2][0].regs[RED-1] = &PORTD;
	map[2][1].regs[RED-1] = &PORTA;
	map[2][2].regs[RED-1] = &PORTA;	
	
}

/*initialize logical matrix*/
void init_map()
{
	int i,j;
	for(i=0;i<=2;i++)
		for(j=0;j<=2;j++)
		map[i][j].state = 0;
}

/*initializare pini matrice joc*/
void initialize_game()
{
	initialize_buttons();
	initialize_leds();
	init_map();
	initialize_map_red_leds();
	initialize_map_green_leds();	
}

/*selectare led pentru alegere mutare urmatoare*/
void light_led(int temp,  int x, int y)
{
	if( map[x][y].state == EMPTY )
	{
		*(map[x][y].regs[player]) &= ~(1<<map[x][y].port[player]);
		_delay_ms(LOCK_INPUT_TIME/2);
		if(temp == 1)
		{
			*(map[x][y].regs[player]) |= (1<<map[x][y].port[player]);	
		}
		else
		{
			map[x][y].state = player+1;				
		}
		
	}
}

/*selectare mutare urmatoare*/
void choose_move()
{
	while(1)
	{
		if ((PINB & (1 << PIN_BUTTON_UP)) == 0) 
		{
			if(x>0)
			{
				x --;
			}	
				if(map[x][y].state == EMPTY)
				light_led(1, x,y);
				
		}
		else
	
		if ((PINB & (1 << PIN_BUTTON_DOWN)) == 0) 
		{
			if(x<2)
			{
				x ++;
			}	
			if(map[x][y].state == EMPTY)
				light_led(1, x,y);			
			
		}
		else
		if ((PINB & (1 << PIN_BUTTON_LEFT)) == 0) 
		{
			if(y<2)
			{
				y++;
			}	
			if(map[x][y].state == EMPTY)
				light_led(1, x,y);			
			
		}
		else
		if ((PINB & (1 << PIN_BUTTON_RIGHT)) == 0) 
		{
			if(y>0)
			{
				y--;
			}	
			if(map[x][y].state == EMPTY)
				light_led(1, x,y);			
			
			
		}
		else
		if ((PINB & (1 << PIN_BUTTON_SELECT)) == 0 && map[x][y].state == EMPTY) 
		{
			light_led(0, x,y);
			return;
		}
	}
	
	
}


/*verifica sfarsit de joc*/
void check_end_of_game()
{
	int i =0;
	int j;
	for(i=0;i<3;i++)
	{
		/* verifica inii */
		if(map[i][0].state == map[i][1].state &&  map[i][1].state == map[i][2].state  && map[i][2].state == map[i][0].state)
			finished = map[i][0].state;
		/* verifica coloane	*/
		if(map[0][i].state == map[1][i].state &&  map[1][i].state == map[2][i].state  && map[2][i].state == map[0][i].state)	
			finished = map[0][i].state;
			
	}
	/* verifica diagonale */
	if(map[0][0].state == map[1][1].state &&  map[1][1].state == map[2][2].state  && map[2][2].state == map[0][0].state)	
		finished = map[0][0].state;
	if(map[0][2].state == map[1][1].state &&  map[1][1].state == map[2][0].state  && map[2][0].state == map[0][2].state)	
		finished = map[0][2].state;
	for(i=0;i<3;i++)
		for(j=0;j<3;j++)
		{
			if(map[i][j].state == EMPTY)
			{
				return;
			}
		}
	finished = DRAW;
}

/*joc lumini matrice leduri pentru sfarsit de joc*/
void end_game()
{
	int i, j;
	int col ;
	for(col =0;col<2;col++)
		for(i=0;i<3;i++)
		{
			for(j=0;j<3;j++)
			{
				*(map[i][j].regs[col]) |= (1<<map[i][j].port[col]);	
			}
		}
	while(1)
	{
	for(i=0;i<3;i++)
	{
		for(j=0;j<3;j++)
		{
			*(map[i][j].regs[player]) &= (1<<map[i][j].port[player]);
	
		}
	}
	_delay_ms(LOCK_INPUT_TIME);
	for(i=0;i<3;i++)
	{
		for(j=0;j<3;j++)
		{
			*(map[i][j].regs[player]) |= (1<<map[i][j].port[player]);
		}
	}
	_delay_ms(LOCK_INPUT_TIME);
	for(i=0;i<3;i++)
	{
		for(j=0;j<3;j++)
		{
			*(map[i][j].regs[player]) &= (1<<map[i][j].port[player]);
		}
	}
	_delay_ms(LOCK_INPUT_TIME);
	
	}
	
}


/*play game*/
void play()
{
	initialize_game();
	finished = 0;
	while(1)
	{
		if(finished!=0)
		{
			end_game();
		}
		else
		{
			choose_move();
		}	
		if( player == RED-1 )
			player = GREEN-1;
		else
			player = RED-1;
			
		check_end_of_game();		
				
	}
	
}

/*metoda folosita pentru testarea ledurilor & debugging*/
void exemplu2()
{
	initialize_game();
	int i, j,col;
	i=j=0;
	while(1)
	{
		if ((PINB & (1 << PIN_BUTTON_LEFT)) == 0) 
		{	
			*(map[j][i].regs[0]) &= ~(1<<map[j][i].port[0]);
			*(map[j][i].regs[1]) |= (1<<map[j][i].port[1]);	
		}
		else
		{
			*(map[j][i].regs[1]) &= ~(1<<map[j][i].port[1]);
			*(map[j][i].regs[0]) |= (1<<map[j][i].port[0]);	
		}
	}
	for(col =1;col>=0;col--)
		for(i=0;i<=2;i++)
			for(j = 0;j<=2;j++)
			{
				*(map[j][i].regs[col]) &= ~(1<<map[j][i].port[col]);
				_delay_ms(LOCK_INPUT_TIME);		
			}
		

	for(i=0;i<=2;i++)
	{
		for(j = 0;j<=2;j++)
		{
			*(map[j][i].regs[col]) |= (1<<map[j][i].port[col]);
			_delay_ms(LOCK_INPUT_TIME);		
		}		
	}
	
}

int main(void)
{
	play();
	return 0;
}

